unit MainUnit; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, LCLProc, Forms, Controls, Graphics, Dialogs,
  ExtCtrls, StdCtrls, FileUtil, Buttons, shellapi, windows;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Image1: TImage;
    Label1: TLabel;
    Panel1: TPanel;
    Timer1: TTimer;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
    procedure Start;
  end;

var
  Form1: TForm1; 

implementation

{ TForm1 }
var
  StartPfad, LazarusPfad, LazarusPfad2, BackUpPfad, fpcPfad: String;
  Ti: Integer;
  

procedure TForm1.FormCreate(Sender: TObject);
var
   MyStringList: TStringList;
   hFormIcon: THandle;

begin
  hFormIcon := LoadIcon(hInstance, 'FORMICON');
  SetClassLong(self.Handle, GCL_HICON, hFormIcon);
  SetClassLong(self.Handle, GCL_HICONSM, hFormIcon);
  Ti := 1;
  StartPfad := ExtractFilePath(ParamStr(0));
  LazarusPfad := StartPfad + 'lazarus\';
  LazarusPfad2 := StartPfad + 'lazarus';
  BackUpPfad := StartPfad + 'Backup\';
  fpcPfad := LazarusPfad + 'fpc\';
  If FileExists(LazarusPfad + 'environmentoptions.xml') = True Then
     begin
       MyStringList := TStringList.Create;
       MyStringList.LoadFromFile(LazarusPfad + 'environmentoptions.xml');
       MyStringList.SaveToFile(BackUpPfad + 'environmentoptions.xml.bak');
       MyStringList.Free;
     end;
  If FileExists(LazarusPfad + 'helpoptions.xml') = True Then
     begin
       MyStringList := TStringList.Create;
       MyStringList.LoadFromFile(LazarusPfad + 'helpoptions.xml');
       MyStringList.SaveToFile(BackUpPfad + 'helpoptions.xml.bak');
       MyStringList.Free;
     end;
  If FileExists(fpcPfad + '2.2.0\bin\i386-win32\fpc.cfg') = True Then
     begin
       MyStringList := TStringList.Create;
       MyStringList.LoadFromFile(fpcPfad + '2.2.0\bin\i386-win32\fpc.cfg');
       MyStringList.SaveToFile(BackUpPfad + 'fpc.cfg.bak');
       MyStringList.Free;
     end;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
   Button1.Visible := False;
   Button2.Visible := False;
   Start;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Ti := Ti + 1;
  If Ti =  2 Then Label1.Caption := 'Lazarus wird fr den Start vorbereitet!';
  if Ti =  6 Then Button1.Click;
  if Ti =  6 Then Label1.Caption := 'Lazarus wird jetzt gestartet';
  if Ti = 10 Then Button2.Click;
  if Ti = 11 Then Close;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  F: TextFile;
  S, S1, S2, S3, S4, S5: String;
  MyStringList: TStringList;

begin
  MyStringList := TStringList.Create;
  AssignFile(F, LazarusPfad + 'environmentoptions.xml');
  Reset     (F);
  while not eof(F) do
    begin
      Readln(F, S);
      If Pos('<LazarusDirectory Value="', S) > 0 Then
        begin
          S := '    <LazarusDirectory Value="' + LazarusPfad + '">';
        end;
      If Pos('<CompilerFilename Value="', S) > 0 Then
        begin
          S := '    <CompilerFilename Value="' + LazarusPfad + 'fpc\2.2.0\bin\i386-win32\ppc386.exe">';
        end;
      If Pos('<FPCSourceDirectory Value="', S) > 0 Then
        begin
          S := '    <FPCSourceDirectory Value="' + LazarusPfad + 'fpc\2.2.0\source\">';
        end;
      If Pos('<MakeFilename Value="', S) > 0 Then
        begin
          S := '    <MakeFilename Value="' + LazarusPfad + 'fpc\2.2.0\bin\i386-win32\make.exe">';
        end;
      If Pos('<TestBuildDirectory Value="', S) > 0 Then
        begin
          S := '    <TestBuildDirectory Value="' + LazarusPfad + 'Tmp\">';
        end;
      If Pos('<DebuggerFilename Value="', S) > 0 Then
        begin
          S := '    <DebuggerFilename Value="' + LazarusPfad + 'mingw\bin\gdb.exe">';
        end;
      If Pos('<AutoSave LastSavedProjectFile="', S) > 0 Then
        begin
          S := '    <AutoSave LastSavedProjectFile="' + LazarusPfad + 'LZTest\project1.lpi" OpenLastProjectAtStart="False"/>';
        end;
      MyStringList.Add(S);
    end;
  CloseFile(F);
  MyStringList.SaveToFile(LazarusPfad + 'environmentoptions.xml');
  MyStringList.Free;
  MyStringList := TStringList.Create;
  AssignFile(F, LazarusPfad + 'helpoptions.xml');
  Reset     (F);
      Readln(F, S);
      MyStringList.Add(S);
      Readln(F, S);
      MyStringList.Add(S);
      Readln(F, S);
      MyStringList.Add(S);
      Readln(F, S);
      MyStringList.Add(S);
      Readln(F, S1);
      If Pos('<BaseURL Value="file://', S1) > 0 Then
        begin
          S1 := '      <BaseURL Value="file://' + LazarusPfad2 + '/docs/html/rtl" />';
        end;
      MyStringList.Add(S1);
      Readln(F, S);
      MyStringList.Add(S);
      Readln(F, S);
      MyStringList.Add(S);
      Readln(F, S2);
      If Pos('<BaseURL Value="file://', S2) > 0 Then
        begin
          S2 := '      <BaseURL Value="file://' + LazarusPfad2 + '/docs/html/fcl" />';
        end;
      MyStringList.Add(S2);
      Readln(F, S);
      MyStringList.Add(S);
      Readln(F, S);
      MyStringList.Add(S);
      Readln(F, S3);
      If Pos('<BaseURL Value="file://', S3) > 0 Then
        begin
          S3 := '      <BaseURL Value="file://' + LazarusPfad2 + '/docs/html/lcl" />';
        end;
      MyStringList.Add(S3);
      Readln(F, S);
      MyStringList.Add(S);
      Readln(F, S);
      MyStringList.Add(S);
      Readln(F, S);
      MyStringList.Add(S);
  CloseFile (F);
  MyStringList.SaveToFile(LazarusPfad + 'helpoptions.xml');
  MyStringList.Free;
  MyStringList := TStringList.Create;
  AssignFile(F, fpcPfad + '2.2.0\bin\i386-win32\fpc.cfg');
  Reset     (F);
  while not eof(F) do
    begin
      Readln(F, S);
      If Pos('# the default language', S) > 0 Then
        begin
          MyStringList.Add(S);
          Readln(F, S);
          S1 := '#-Fr' + fpcPfad + '2.2.0/msg/errore.msg';
          MyStringList.Add(S1);
          Readln(F, S);
          S2 := '#-Fr' + fpcPfad + '2.2.0/msg/errorn.msg';
          MyStringList.Add(S2);
          Readln(F, S);
          S3 := '#-Fr' + fpcPfad + '2.2.0/msg/errores.msg';
          MyStringList.Add(S3);
          Readln(F, S);
          S4 := '#-Fr' + fpcPfad + '2.2.0/msg/errord.msg';
          MyStringList.Add(S4);
          Readln(F, S);
          S5 := '#-Fr' + fpcPfad + '2.2.0/msg/errorr.msg';
          MyStringList.Add(S5);
          Readln(F, S);
        end;
      If Pos('# path to the gcclib', S) > 0 Then
        begin
          MyStringList.Add(S);
          Readln(F, S);
          S1 := '#-Fl' + fpcPfad + '2.2.0/lib';
          MyStringList.Add(S1);
          Readln(F, S);
        end;
      If Pos('# if you tell them compiler/ide to build the project (FK)', S) > 0 Then
        begin
          MyStringList.Add(S);
          Readln(F, S);
          S1 := '#-Fi' + fpcPfad + '2.2.0/source/rtl/inc;' + fpcPfad + '2.2.0/source/rtl/i386';
          MyStringList.Add(S1);
          Readln(F, S);
        end;
      If Pos('# searchpath for objectfiles', S) > 0 Then
        begin
          MyStringList.Add(S);
          Readln(F, S);
          S1 := '#-Fo' + fpcPfad + '2.2.0/source/rtl/inc;' + fpcPfad + '2.2.0/source/rtl/i386';
          MyStringList.Add(S1);
          Readln(F, S);
        end;
      If Pos('# searchpath for units and other system dependent things', S) > 0 Then
        begin
          MyStringList.Add(S);
          Readln(F, S);
          S1 := '-Fu' + fpcPfad + '2.2.0/units/$FPCTARGET/';
          MyStringList.Add(S1);
          Readln(F, S);
          S2 := '-Fu' + fpcPfad + '2.2.0/units/$FPCTARGET/*';
          MyStringList.Add(S2);
          Readln(F, S);
          S3 := '-Fu' + fpcPfad + '2.2.0/units/$FPCTARGET/rtl';
          MyStringList.Add(S3);
          Readln(F, S);
        end;
      If Pos('# searchpath for libraries', S) > 0 Then
        begin
          MyStringList.Add(S);
          Readln(F, S);
          S1 := '#-Fl' + fpcPfad + '2.2.0/lib';
          MyStringList.Add(S1);
          Readln(F, S);
        end;
      If Pos('# searchpath for tools', S) > 0 Then
        begin
          MyStringList.Add(S);
          Readln(F, S);
          S1 := '-FD' + fpcPfad + '2.2.0/bin/$FPCTARGET';
          MyStringList.Add(S1);
          Readln(F, S);
        end;
      MyStringList.Add(S);
    end;
  CloseFile(F);
  MyStringList.SaveToFile(fpcPfad + '2.2.0\bin\i386-win32\fpc.cfg');
  MyStringList.Free;
 { AssignFile(F, fpcPfad + '2.2.0\bin\i386-win32\fpc.cfg');
  Rewrite    (F);
  Writeln(F, '#');
  Writeln(F, '# Config file generated by fpcmkcfg on 19.10.2007 - 21:26:45');
  Writeln(F, '# Example fpc.cfg for Free Pascal Compiler');
  Writeln(F, '#');
  Writeln(F, '');
  Writeln(F, '# ----------------------');
  Writeln(F, '# Defines (preprocessor)');
  Writeln(F, '# ----------------------');
  Writeln(F, '');
  Writeln(F, '#');
  Writeln(F, '# nested #IFNDEF, #IFDEF, #ENDIF, #ELSE, #DEFINE, #UNDEF are allowed');
  Writeln(F, '#');
  Writeln(F, '# -d is the same as #DEFINE');
  Writeln(F, '# -u is the same as #UNDEF');
  Writeln(F, '#');
  Writeln(F, '');
  Writeln(F, '#');
  Writeln(F, '# Some examples (for switches see below, and the -? helppages)');
  Writeln(F, '#');
  Writeln(F, '# Try compiling with the -dRELEASE or -dDEBUG on the commandline');
  Writeln(F, '#');
  Writeln(F, '');
  Writeln(F, '# For a release compile with optimizes and strip debuginfo');
  Writeln(F, '#IFDEF RELEASE');
  Writeln(F, '  -O2');
  Writeln(F, '  -Xs');
  Writeln(F, '  #WRITE Compiling Release Version');
  Writeln(F, '#ENDIF');
  Writeln(F, '');
  Writeln(F, '# For a debug version compile with debuginfo and all codegeneration checks on');
  Writeln(F, '#IFDEF DEBUG');
  Writeln(F, '  -glh');
  Writeln(F, '  -Crtoi');
  Writeln(F, '  #WRITE Compiling Debug Version');
  Writeln(F, '#ENDIF');
  Writeln(F, '');
  Writeln(F, '# ----------------');
  Writeln(F, '# Parsing switches');
  Writeln(F, '# ----------------');
  Writeln(F, '');
  Writeln(F, '# Pascal language mode');
  Writeln(F, '#      -Mfpc      free pascal dialect (default)');
  Writeln(F, '#      -Mobjfpc   switch some Delphi 2 extensions on');
  Writeln(F, '#      -Mdelphi   tries to be Delphi compatible');
  Writeln(F, '#      -Mtp       tries to be TP/BP 7.0 compatible');
  Writeln(F, '#      -Mgpc      tries to be gpc compatible');
  Writeln(F, '#      -Mmacpas   tries to be compatible to the macintosh pascal dialects');
  Writeln(F, '#');
  Writeln(F, '# Turn on Object Pascal extensions by default');
  Writeln(F, '#-Mobjfpc');
  Writeln(F, '');
  Writeln(F, '# Assembler reader mode');
  Writeln(F, '#      -Rdefault  use default assembler');
  Writeln(F, '#      -Ratt      read AT&T style assembler');
  Writeln(F, '#      -Rintel    read Intel style assembler');
  Writeln(F, '#');
  Writeln(F, '# All assembler blocks are AT&T styled by default');
  Writeln(F, '#-Ratt');
  Writeln(F, '');
  Writeln(F, '# Semantic checking');
  Writeln(F, '#      -S2        same as -Mobjfpc');
  Writeln(F, '#      -Sc        supports operators like C (*=,+=,/= and -=)');
  Writeln(F, '#      -Sa        include assertion code.');
  Writeln(F, '#      -Sd        same as -Mdelphi');
  Writeln(F, '#      -Se<x>     compiler stops after the <x> errors (default is 1)');
  Writeln(F, '#      -Sg        allow LABEL and GOTO');
  Writeln(F, '#      -Sh        Use ansistrings');
  Writeln(F, '#      -Si        support C++ styled INLINE');
  Writeln(F, '#      -SI<x>     set interface style to <x>');
  Writeln(F, '#         -SIcomCOM compatible interface (default)');
  Writeln(F, '#         -SIcorbaCORBA compatible interface');
  Writeln(F, '#      -Sm        support macros like C (global)');
  Writeln(F, '#      -So        same as -Mtp');
  Writeln(F, '#      -Sp        same as -Mgpc');
  Writeln(F, '#      -Ss        constructor name must be init (destructor must be done)');
  Writeln(F, '#      -St        allow static keyword in objects');
  Writeln(F, '#');
  Writeln(F, '# Allow goto, inline, C-operators, C-vars');
  Writeln(F, '-Sgic');
  Writeln(F, '');
  Writeln(F, '# ---------------');
  Writeln(F, '# Code generation');
  Writeln(F, '# ---------------');
  Writeln(F, '');
  Writeln(F, '# Uncomment the next line if you always want static/dynamic units by default');
  Writeln(F, '# (can be overruled with -CD, -CS at the commandline)');
  Writeln(F, '#-CS');
  Writeln(F, '#-CD');
  Writeln(F, '');
  Writeln(F, '# Set the default heapsize to 8Mb');
  Writeln(F, '#-Ch8000000');
  Writeln(F, '');
  Writeln(F, '# Set default codegeneration checks (iocheck, overflow, range, stack)');
  Writeln(F, '#-Ci');
  Writeln(F, '#-Co');
  Writeln(F, '#-Cr');
  Writeln(F, '#-Ct');
  Writeln(F, '');
  Writeln(F, '# Optimizer switches for i386 compiler');
  Writeln(F, '# -Os        generate smaller code');
  Writeln(F, '# -O1        level 1 optimizations (quick optimizations)');
  Writeln(F, '# -O2        level 2 optimizations (-O1 + slower optimizations)');
  Writeln(F, '# -O3        level 3 optimizations (same as -O2u)');
  Writeln(F, '# -Oa=N      set alignment to N');
  Writeln(F, '# -OoX       switch on optimalization X.');
  Writeln(F, '# -OoNOX     switch off optimalization X.');
  Writeln(F, '#               X is one of REGVAR UNCERTAIN STACKFRAME PEEPHOLE ASMCSE LOOPUNROLL');
  Writeln(F, '# -OpCPU     set target processor.');
  Writeln(F, '#             CPU is one of 386, PENTIUM, PENTIUM2, PENTIUM3, PENTIUM4, PENTIUMM');
  Writeln(F, '');
  Writeln(F, '');
  Writeln(F, '# -----------------------');
  Writeln(F, '# Set Filenames and Paths');
  Writeln(F, '# -----------------------');
  Writeln(F, '');
  Writeln(F, '# Both slashes and backslashes are allowed in paths');
  Writeln(F, '');
  Writeln(F, '# path to the messagefile, not necessary anymore but can be used to override');
  Writeln(F, '# the default language');
  Writeln(F, '#-Fr' + LazarusPfad2 + '\fpc\2.2.0/msg/errore.msg');
  Writeln(F, '#-Fr' + LazarusPfad2 + '\fpc\2.2.0/msg/errorn.msg');
  Writeln(F, '#-Fr' + LazarusPfad2 + '\fpc\2.2.0/msg/errores.msg');
  Writeln(F, '#-Fr' + LazarusPfad2 + '\fpc\2.2.0/msg/errord.msg');
  Writeln(F, '#-Fr' + LazarusPfad2 + '\fpc\2.2.0/msg/errorr.msg');
  Writeln(F, '');
  Writeln(F, '# path to the gcclib');
  Writeln(F, '#-Fl' + LazarusPfad2 + '\fpc\2.2.0/lib');
  Writeln(F, '');
  Writeln(F, '# searchpath for includefiles');
  Writeln(F, '#-Fi/pp/inc;/pp/rtl/inc');
  Writeln(F, '');
  Writeln(F, '# searchpath for includefiles');
  Writeln(F, '# release them only if you know what you do');
  Writeln(F, '# because this could cause a rebuild of the runtime library');
  Writeln(F, '# if you tell them compiler/ide to build the project (FK)');
  Writeln(F, '#-Fi' + LazarusPfad2 + '\fpc\2.2.0/source/rtl/inc;' + LazarusPfad2 + '\fpc\2.2.0/source/rtl/i386');
  Writeln(F, '');
  Writeln(F, '# searchpath for objectfiles');
  Writeln(F, '#-Fo' + LazarusPfad2 + '\fpc\2.2.0/source/rtl/inc;' + LazarusPfad2 + '\fpc\2.2.0/source/rtl/i386');
  Writeln(F, '');
  Writeln(F, '# searchpath for units and other system dependent things');
  Writeln(F, '-Fu' + LazarusPfad2 + '\fpc\2.2.0/units/$FPCTARGET/');
  Writeln(F, '-Fu' + LazarusPfad2 + '\fpc\2.2.0/units/$FPCTARGET/*');
  Writeln(F, '-Fu' + LazarusPfad2 + '\fpc\2.2.0/units/$FPCTARGET/rtl');
  Writeln(F, '');
  Writeln(F, '# searchpath for libraries');
  Writeln(F, '#-Fl' + LazarusPfad2 + '\fpc\2.2.0/lib');
  Writeln(F, '#-Fl/lib;/usr/lib');
  Writeln(F, '');
  Writeln(F, '# searchpath for tools');
  Writeln(F, '-FD' + LazarusPfad2 + '\fpc\2.2.0/bin/$FPCTARGET');
  Writeln(F, '');
  Writeln(F, '# binutils prefix for cross compiling');
  Writeln(F, '#IFDEF FPC_CROSSCOMPILING');
  Writeln(F, '  -XP$FPCTARGET-');
  Writeln(F, '#ENDIF');
  Writeln(F, '');
  Writeln(F, '');
  Writeln(F, '# -------------');
  Writeln(F, '# Linking');
  Writeln(F, '# -------------');
  Writeln(F, '');
  Writeln(F, '# generate always debugging information for GDB (slows down the compiling');
  Writeln(F, '# process)');
  Writeln(F, '#      -gc        generate checks for pointers');
  Writeln(F, '#      -gd        use dbx');
  Writeln(F, '#      -gg        use gsym');
  Writeln(F, '#      -gh        use heap trace unit (for memory leak debugging)');
  Writeln(F, '#      -gl        use line info unit to show more info for backtraces');
  Writeln(F, '#      -gv        generates programs tracable with valgrind');
  Writeln(F, '#      -gw        generate dwarf debugging info');
  Writeln(F, '#');
  Writeln(F, '# Enable debuginfo and use the line info unit by default');
  Writeln(F, '#-gl');
  Writeln(F, '');
  Writeln(F, '# always pass an option to the linker');
  Writeln(F, '#-k-s');
  Writeln(F, '');
  Writeln(F, '# Always strip debuginfo from the executable');
  Writeln(F, '-Xs');
  Writeln(F, '');
  Writeln(F, '');
  Writeln(F, '# -------------');
  Writeln(F, '# Miscellaneous');
  Writeln(F, '# -------------');
  Writeln(F, '');
  Writeln(F, '# Write always a nice FPC logo ;)');
  Writeln(F, '-l');
  Writeln(F, '');
  Writeln(F, '# Verbosity');
  Writeln(F, '#      e : Show errors (default)       d : Show debug info');
  Writeln(F, '#      w : Show warnings               u : Show unit info');
  Writeln(F, '#      n : Show notes                  t : Show tried/used files');
  Writeln(F, '#      h : Show hints                  m : Show defined macros');
  Writeln(F, '#      i : Show general info           p : Show compiled procedures');
  Writeln(F, '#      l : Show linenumbers            c : Show conditionals');
  Writeln(F, '#      a : Show everything             0 : Show nothing (except errors)');
  Writeln(F, '#      b : Show all procedure          r : Rhide/GCC compatibility mode');
  Writeln(F, '#          declarations if an error    x : Executable info (Win32 only)');
  Writeln(F, '#          occurs');
  Writeln(F, '#');
  Writeln(F, '# Display Info, Warnings, Notes and Hints');
  Writeln(F, '-viwn');
  Writeln(F, '# If you dont want so much verbosity use');
  Writeln(F, '#-vw');
  CloseFile(F); }
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  If FileExists(LazarusPfad + 'Lazarus.exe') Then
  shellexecute(handle,nil, PChar(LazarusPfad + 'Lazarus.exe'), '', PChar(LazarusPfad), 6);
end;

procedure TForm1.Start;
begin
 { while Ti < 100 do
    begin
     if Ti > 20 Then Button1.Click;
     if Ti > 40 Then Button2.Click;
     if Ti > 60 Then Close;
    end;  }
end;

initialization
  {$I mainunit.lrs}

end.

